'From Squeak3.10beta of 22 July 2007 [latest update: #7137] on 9 October 2007 at 2:09:15 pm'!
"Change Set:		DeltaStream-base-fixes
Date:			26 August 2007
Author:			mtf

<your descriptive text goes here>"!

AbstractEvent subclass: #CommentedEvent
	instanceVariableNames: 'oldComment newComment oldStamp newStamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Change Notification'!
Object subclass: #MethodAddition
	instanceVariableNames: 'text category changeStamp requestor logSource myClass methodAndNode selector compiledMethod priorMethodOrNil oldCategory '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Loading'!
ModifiedEvent subclass: #ModifiedMethodEvent
	instanceVariableNames: 'oldProtocol newProtocol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Change Notification'!
!CommentedEvent methodsFor: 'printing' stamp: 'rw 7/1/2003 11:37'!
printEventKindOn: aStream

	aStream nextPutAll: 'Commented'! !

!CommentedEvent methodsFor: 'testing' stamp: 'rw 7/1/2003 11:37'!
isCommented

	^true! !

!CommentedEvent methodsFor: 'accessing' stamp: 'gk 8/15/2007 01:17'!
newComment
	^newComment! !

!CommentedEvent methodsFor: 'accessing' stamp: 'gk 8/15/2007 01:17'!
newComment: aString
	newComment := aString! !

!CommentedEvent methodsFor: 'accessing' stamp: 'gk 8/23/2007 21:37'!
newStamp
	^newStamp! !

!CommentedEvent methodsFor: 'accessing' stamp: 'gk 8/23/2007 21:37'!
newStamp: aString
	newStamp := aString! !

!CommentedEvent methodsFor: 'accessing' stamp: 'gk 8/15/2007 01:18'!
oldComment
	^oldComment! !

!CommentedEvent methodsFor: 'accessing' stamp: 'gk 8/15/2007 01:17'!
oldComment: aString
	oldComment := aString! !

!CommentedEvent methodsFor: 'accessing' stamp: 'gk 8/23/2007 21:37'!
oldStamp
	^oldStamp! !

!CommentedEvent methodsFor: 'accessing' stamp: 'gk 8/23/2007 21:37'!
oldStamp: aString
	oldStamp := aString! !


!CommentedEvent class methodsFor: 'accessing' stamp: 'rw 7/10/2003 12:08'!
changeKind

	^#Commented! !

!CommentedEvent class methodsFor: 'accessing'!
class: aClass oldComment: oldComment newComment: newComment

	^(self class: aClass) oldComment: oldComment; newComment: newComment; yourself! !

!CommentedEvent class methodsFor: 'accessing' stamp: 'gk 8/23/2007 21:36'!
class: aClass oldComment: oldComment newComment: newComment oldStamp: oldStamp newStamp: newStamp

	^(self class: aClass)
		oldComment: oldComment;
		newComment: newComment;
		oldStamp: oldStamp;
		newStamp: newStamp; yourself! !

!CommentedEvent class methodsFor: 'accessing' stamp: 'rw 7/10/2003 11:20'!
supportedKinds

	^Array with: self classKind! !


!EventManagerTest methodsFor: 'running-remove actions' stamp: 'gk 8/14/2007 23:51'!
testRemoveActionsWithReceiver

	| action |
	eventSource
		when: #anEvent send: #size to: eventListener;
		when: #anEvent send: #getTrue to: self;
		when: #anEvent: send: #fizzbin to: self.
	self assert: (eventSource hasActionsWithReceiver: self).
	eventSource removeActionsWithReceiver: self.
	action := eventSource actionForEvent: #anEvent.
	self assert: (action respondsTo: #receiver).
	self assert: ((action receiver == self) not).
	self assert: ((eventSource hasActionsWithReceiver: self) not)! !


!MethodAddition methodsFor: 'as yet unclassified' stamp: 'mtf 10/9/2007 10:30'!
createCompiledMethod
	methodAndNode := myClass compile: text asString classified: category notifying: requestor
							trailer: myClass defaultMethodTrailer ifFail: [^nil].
	selector := methodAndNode selector.
	compiledMethod := methodAndNode method.
	self writeSourceToLog.
	priorMethodOrNil := myClass compiledMethodAt: selector ifAbsent: [nil].
	oldCategory := myClass organization categoryOfElement: selector.
! !

!MethodAddition methodsFor: 'as yet unclassified' stamp: 'mtf 10/9/2007 10:30'!
notifyObservers
	SystemChangeNotifier uniqueInstance 
		doSilently: [myClass organization classify: selector under: category].
	priorMethodOrNil isNil
		ifTrue: [SystemChangeNotifier uniqueInstance methodAdded: compiledMethod selector: selector inProtocol: category class: myClass requestor: requestor]
		ifFalse: [SystemChangeNotifier uniqueInstance methodChangedFrom: priorMethodOrNil to: compiledMethod selector: selector inClass: myClass oldProtocol: oldCategory newProtocol: category requestor: requestor].
	"The following code doesn't seem to do anything."
	myClass instanceSide noteCompilationOf: selector meta: myClass isClassSide.
! !


!ModifiedEvent methodsFor: 'testing' stamp: 'mtf 10/9/2007 10:16'!
isProtocolModified
	^ false! !


!ModifiedClassDefinitionEvent methodsFor: 'accessing' stamp: 'gk 8/22/2007 01:10'!
classVarNames
	^ item classVarNames! !

!ModifiedClassDefinitionEvent methodsFor: 'accessing' stamp: 'gk 8/22/2007 00:11'!
instVarNames
	^ item instVarNames! !

!ModifiedClassDefinitionEvent methodsFor: 'accessing' stamp: 'gk 8/22/2007 01:10'!
oldClassVarNames
	^ oldItem classVarNames! !

!ModifiedClassDefinitionEvent methodsFor: 'accessing' stamp: 'gk 8/22/2007 00:30'!
oldInstVarNames
	^ oldItem instVarNames! !

!ModifiedClassDefinitionEvent methodsFor: 'accessing' stamp: 'gk 8/21/2007 02:23'!
oldTypeOfClass
	^ oldItem typeOfClass! !

!ModifiedClassDefinitionEvent methodsFor: 'accessing' stamp: 'gk 8/21/2007 02:23'!
typeOfClass
	^ item typeOfClass! !

!ModifiedClassDefinitionEvent methodsFor: 'testing' stamp: 'gk 8/21/2007 02:21'!
isTypeModified
	^ item typeOfClass ~~ oldItem typeOfClass! !


!ModifiedMethodEvent methodsFor: 'testing' stamp: 'test 8/26/2007 00:18'!
isProtocolModified
	^ self oldProtocol ~~ self newProtocol! !

!ModifiedMethodEvent methodsFor: 'accessing' stamp: 'mtf 8/25/2007 23:17'!
newProtocol
	^ newProtocol! !

!ModifiedMethodEvent methodsFor: 'accessing' stamp: 'mtf 8/25/2007 23:17'!
newProtocol: anObject
	newProtocol := anObject! !

!ModifiedMethodEvent methodsFor: 'accessing' stamp: 'mtf 8/25/2007 23:17'!
oldProtocol
	^ oldProtocol! !

!ModifiedMethodEvent methodsFor: 'accessing' stamp: 'mtf 8/25/2007 23:17'!
oldProtocol: anObject
	oldProtocol := anObject! !


!SystemChangeNotifier methodsFor: 'system triggers' stamp: 'gk 8/23/2007 21:35'!
class: aClass oldComment: oldComment newComment: newComment oldStamp: oldStamp newStamp: newStamp
	"A class was commented in the system."

	self trigger: (CommentedEvent class: aClass oldComment: oldComment newComment: newComment oldStamp: oldStamp newStamp: newStamp)! !

!SystemChangeNotifier methodsFor: 'system triggers' stamp: 'mtf 8/25/2007 23:21'!
methodChangedFrom: oldMethod to: newMethod selector: aSymbol inClass: aClass oldProtocol: oldProtocol newProtocol: newProtocol requestor: requestor
	self trigger: ((ModifiedMethodEvent
					methodChangedFrom: oldMethod
					to: newMethod
					selector: aSymbol 
					inClass: aClass
					requestor: requestor)
					oldProtocol: oldProtocol;
					newProtocol: newProtocol)! !

!TAccessingMethodDictDescription methodsFor: 'accessing method dictionary' stamp: 'mtf 8/29/2007 20:02'!
addAndClassifySelector: selector withMethod: compiledMethod inProtocol: category notifying: requestor
	| priorMethodOrNil oldProtocol newProtocol |
	priorMethodOrNil := self compiledMethodAt: selector ifAbsent: [nil].
	self addSelectorSilently: selector withMethod: compiledMethod.
	oldProtocol := self organization categoryOfElement: selector.
	SystemChangeNotifier uniqueInstance 
		doSilently: [self organization classify: selector under: category].
	newProtocol := self organization categoryOfElement: selector.
	priorMethodOrNil isNil
		ifTrue: [SystemChangeNotifier uniqueInstance methodAdded: compiledMethod selector: selector inProtocol: category class: self requestor: requestor]
		ifFalse: [SystemChangeNotifier uniqueInstance methodChangedFrom: priorMethodOrNil to: compiledMethod selector: selector inClass: self oldProtocol: oldProtocol newProtocol: newProtocol requestor: requestor].! !


!TCommentDescription methodsFor: 'fileIn/Out' stamp: 'mtf 8/29/2007 20:07'!
classComment: aString stamp: aStamp
	"Store the comment, aString or Text or RemoteString, associated with the class we are organizing.
	Empty string gets stored only if had a non-empty one before."

	| ptr header file oldCommentRemoteStr oldComment oldStamp |
	oldComment := self organization classComment.
	oldStamp := self organization commentStamp.
	(aString isKindOf: RemoteString) ifTrue:
		[SystemChangeNotifier uniqueInstance class: self oldComment: oldComment newComment: aString string oldStamp: oldStamp newStamp: aStamp.
		^ self organization classComment: aString stamp: aStamp].

	oldCommentRemoteStr := self organization commentRemoteStr.
	(aString size = 0) & (oldCommentRemoteStr == nil) ifTrue: [^ self organization classComment: nil].
		"never had a class comment, no need to write empty string out"

	ptr := oldCommentRemoteStr ifNil: [0] ifNotNil: [oldCommentRemoteStr sourcePointer].
	SourceFiles ifNotNil: [(file := SourceFiles at: 2) ifNotNil:
		[file setToEnd; cr; nextPut: $!!.	"directly"
		"Should be saying (file command: 'H3') for HTML, but ignoring it here"
		header := String streamContents: [:strm | strm nextPutAll: self name;
			nextPutAll: ' commentStamp: '.
			aStamp storeOn: strm.
			strm nextPutAll: ' prior: '; nextPutAll: ptr printString].
		file nextChunkPut: header]].
	self organization classComment: (RemoteString newString: aString onFileNumber: 2) stamp: aStamp.
	SystemChangeNotifier uniqueInstance class: self oldComment: oldComment newComment: aString oldStamp: oldStamp newStamp: aStamp! !



SystemChangeNotifier removeSelector: #classCommented:!
SystemChangeNotifier removeSelector: #classCommented:inCategory:!
Object subclass: #MethodAddition
	instanceVariableNames: 'text category changeStamp requestor logSource myClass methodAndNode selector compiledMethod priorMethodOrNil oldCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Loading'!
